#ifndef _ROME_TBL_H_
#define _ROME_RBL_H_

struct ROME
{
	char	*r;
	char	*k;
};

static struct ROME tbl_a[] = {
				"A", "",
				"I", "",
				"U", "",
				"E", "",
				"O", "",
				"-", "[",
				"~", "`",
				"!", "I",
				"?", "H",
				".", "B",
				",", "A",
			};

static struct ROME tbl_b[] = {
				"BA", "",
				"BI", "",
				"BU", "",
				"BE", "",
				"BO", "",
				"BYA", "т",
				"BYI", "т",
				"BYU", "т",
				"BYE", "т",
				"BYO", "т",
			};

static struct ROME tbl_c[] = {
				"CHI", "",
				"CYA", "",
				"CHA", "",
				"CYI", "",
				"CYU", "",
				"CHU", "",
				"CYE", "",
				"CHE", "",
				"CYO", "",
				"CHO", "",
			};

static struct ROME tbl_d[] = {
				"DA", "",
				"DI", "",
				"DU", "",
				"DE", "",
				"DO", "",
				"DYA", "",
				"DYI", "",
				"DYU", "",
				"DYE", "",
				"DYO", "",
				"DHA", "ł",
				"DHI", "ł",
				"DHU", "ł",
				"DHE", "ł",
				"DHO", "ł",
				"DWU", "ł",
			};

static struct ROME tbl_f[] = {
				"FA", "ӂ",
				"FI", "ӂ",
				"FU", "",
				"FE", "ӂ",
				"FO", "ӂ",
				"FYA", "ӂ",
				"FYI", "ӂ",
				"FYU", "ӂ",
				"FYE", "ӂ",
				"FYO", "ӂ",
			};

static struct ROME tbl_g[] = {
				"GA", "",
				"GI", "",
				"GU", "",
				"GE", "",
				"GO", "",
				"GYA", "",
				"GYI", "",
				"GYU", "",
				"GYE", "",
				"GYO", "",
				"GWA", "",
			};

static struct ROME tbl_h[] = {
				"HA", "",
				"HI", "",
				"HU", "",
				"HE", "",
				"HO", "",
				"HYA", "Ђ",
				"HYI", "Ђ",
				"HYU", "Ђ",
				"HYE", "Ђ",
				"HYO", "Ђ",
			};

static struct ROME tbl_j[] = {
				"JA", "",
				"JI", "",
				"JU", "",
				"JE", "",
				"JO", "",
				"JYA", "",
				"JYI", "",
				"JYU", "",
				"JYE", "",
				"JYO", "",
			};

static struct ROME tbl_k[] = {
				"KA", "",
				"KI", "",
				"KU", "",
				"KE", "",
				"KO", "",
				"KYA", "",
				"KYI", "",
				"KYU", "",
				"KYE", "",
				"KYO", "",
				"KWA", "",
			};

static struct ROME tbl_l[] = {
				"LA", "",
				"LI", "",
				"LU", "",
				"LE", "",
				"LO", "",
				"LTU", "",
				"LYA", "",
				"LYI", "",
				"LYU", "",
				"LYE", "",
				"LYO", "",
			};

static struct ROME tbl_m[] = {
				"MA", "",
				"MI", "",
				"MU", "",
				"ME", "",
				"MO", "",
				"MYA", "݂",
				"MYI", "݂",
				"MYU", "݂",
				"MYE", "݂",
				"MYO", "݂",
			};

static struct ROME tbl_n[] = {
				"NA", "",
				"NI", "",
				"NU", "",
				"NE", "",
				"NO", "",
				"NYA", "ɂ",
				"NYI", "ɂ",
				"NYU", "ɂ",
				"NYE", "ɂ",
				"NYO", "ɂ",
				"NN", "",
			};

static struct ROME tbl_p[] = {
				"PA", "",
				"PI", "",
				"PU", "",
				"PE", "",
				"PO", "",
				"PYA", "҂",
				"PYI", "҂",
				"PYU", "҂",
				"PYE", "҂",
				"PYO", "҂",
			};

static struct ROME tbl_r[] = {
				"RA", "",
				"RI", "",
				"RU", "",
				"RE", "",
				"RO", "",
				"RYA", "",
				"RYI", "股",
				"RYU", "",
				"RYE", "肥",
				"RYO", "",
			};

static struct ROME tbl_s[] = {
				"SA", "",
				"SI", "",
				"SHI", "",
				"SU", "",
				"SE", "",
				"SO", "",
				"SYA", "",
				"SYI", "",
				"SYU", "",
				"SYE", "",
				"SYO", "",
				"SHA", "",
				"SHU", "",
				"SHE", "",
				"SHO", "",
			};

static struct ROME tbl_t[] = {
				"TA", "",
				"TI", "",
				"TU", "",
				"TSU", "",
				"TE", "",
				"TO", "",
				"XTU", "",
				"TYA", "",
				"TYI", "",
				"TYU", "",
				"TYE", "",
				"TYO", "",
				"TSA", "",
				"TSI", "",
				"TSE", "",
				"TSO", "",
				"THA", "Ă",
				"THI", "Ă",
				"THU", "Ă",
				"THE", "Ă",
				"THO", "Ă",
				"TWU", "Ƃ",
			};

static struct ROME tbl_v[] = {
				"VA", "J",
				"VI", "J",
				"VU", "J",
				"VE", "J",
				"VO", "J",
			};

static struct ROME tbl_w[] = {
				"WA", "",
				"WI", "",
				"WU", "",
				"WE", "",
				"WO", "",
			};

static struct ROME tbl_x[] = {
				"XA", "",
				"XI", "",
				"XU", "",
				"XE", "",
				"XO", "",
				"XYA", "",
				"XYI", "",
				"XYU", "",
				"XYE", "",
				"XYO", "",
				"XTU", "",
			};

static struct ROME tbl_y[] = {
				"YA", "",
				"YI", "",
				"YU", "",
				"YE", "",
				"YO", "",
			};

static struct ROME tbl_z[] = {
				"ZA", "",
				"ZI", "",
				"ZU", "",
				"ZE", "",
				"ZO", "",
				"ZYA", "",
				"ZYI", "",
				"ZYU", "",
				"ZYE", "",
				"ZYO", "",
			};

static struct ROME *tbl_idx[] = {
				tbl_a,
				tbl_b,
				tbl_c,
				tbl_d,
				NULL,
				tbl_f,
				tbl_g,
				tbl_h,
				NULL,
				tbl_j,
				tbl_k,
				tbl_l,
				tbl_m,
				tbl_n,
				NULL,
				tbl_p,
				NULL,
				tbl_r,
				tbl_s,
				tbl_t,
				NULL,
				tbl_v,
				tbl_w,
				tbl_x,
				tbl_y,
				tbl_z,
			};

static int tbl_idx_size[] = {
				sizeof(tbl_a) / sizeof(struct ROME),
				sizeof(tbl_b) / sizeof(struct ROME),
				sizeof(tbl_c) / sizeof(struct ROME),
				sizeof(tbl_d) / sizeof(struct ROME),
				0,
				sizeof(tbl_f) / sizeof(struct ROME),
				sizeof(tbl_g) / sizeof(struct ROME),
				sizeof(tbl_h) / sizeof(struct ROME),
				0,
				sizeof(tbl_j) / sizeof(struct ROME),
				sizeof(tbl_k) / sizeof(struct ROME),
				sizeof(tbl_l) / sizeof(struct ROME),
				sizeof(tbl_m) / sizeof(struct ROME),
				sizeof(tbl_n) / sizeof(struct ROME),
				0,
				sizeof(tbl_p) / sizeof(struct ROME),
				0,
				sizeof(tbl_r) / sizeof(struct ROME),
				sizeof(tbl_s) / sizeof(struct ROME),
				sizeof(tbl_t) / sizeof(struct ROME),
				0,
				sizeof(tbl_v) / sizeof(struct ROME),
				sizeof(tbl_w) / sizeof(struct ROME),
				sizeof(tbl_x) / sizeof(struct ROME),
				sizeof(tbl_y) / sizeof(struct ROME),
				sizeof(tbl_z) / sizeof(struct ROME),
			};

#endif
